/* ServerOFF */
/* Руссифицированно */

#include <amxmodx>
#include <amxmisc>

#define PLUGIN "ServerOFF"
#define VERSION "0.3"
#define AUTHOR "ZETA [M|E|N]"


public plugin_init() {
	register_plugin("ServerOFF", "0.1", "ZETA [M|E|N]")
	register_clcmd( "say /serveroff","menu_serveroff",ADMIN_CVAR,"")
	register_cvar("so_minutes","0")
	register_cvar("so_hours","0")
}

new seconds,hours,minutes

public plugin_cfg() {
	if(get_cvar_num("so_minutes")!=0 || get_cvar_num("so_hours")!=0) {
		minutes=get_cvar_num("so_minutes")
		hours=get_cvar_num("so_hours")
		set_task (1.0, "message",36,_,_,"b")
		}
}

public menu_serveroff(id,level,cid) {
	if(!cmd_access(id,level,cid,0))
	return PLUGIN_HANDLED
	
	new menu = menu_create("\rServerOFF", "menu_handler")
	menu_additem(menu, "\wВыключить через 120 мин.", "1")
	menu_additem(menu, "\wВыключить через 60 мин.", "2")
	menu_additem(menu, "\wВыключить через 30 мин.", "3")
	menu_additem(menu, "\wВыключить через 10 мин.", "4")
	menu_additem(menu, "\wВыключить в конце карты", "5")
	menu_additem(menu, "\wВыключить сейчас", "6")
	menu_setprop(menu, MPROP_EXIT, MEXIT_ALL)
	menu_display(id, menu, 0)
	return PLUGIN_CONTINUE
	}
	
public menu_handler(id, menu, item) {
	if (item == MENU_EXIT) {
	menu_destroy(menu)
	return PLUGIN_HANDLED
	}

	new data[6], iName[64]
	new access, callback
	menu_item_getinfo(menu, item, access, data,5, iName, 63, callback)
	new key = str_to_num(data)
	
	switch(key) {
	case 1:{
		remove_task(36)
		hours=1;minutes=59,seconds=59
		set_task (1.0, "message",36,_,_,"b")
		menu_destroy(menu)
		return PLUGIN_HANDLED
		}
	
	case 2:{
		remove_task(36)
		hours=0;minutes=59,seconds=59
		set_task (1.0, "message",36,_,_,"b")
		menu_destroy(menu)
		return PLUGIN_HANDLED
		}
	
	case 3:{
		remove_task(36)
		hours=0;minutes=29,seconds=59
		set_task (1.0, "message",36,_,_,"b")
		menu_destroy(menu)
		return PLUGIN_HANDLED
		}
		
	case 4:{
		remove_task(36)
		hours=0;minutes=9,seconds=59
		set_task (1.0, "message",36,_,_,"b")
		menu_destroy(menu)
		return PLUGIN_HANDLED
		}
	case 5:{
		remove_task(36)
		new timeleft=get_timeleft()
		hours=timeleft/3600;
		minutes=timeleft/60
		seconds=timeleft%60
		set_task (1.0, "message",36,_,_,"b")
		menu_destroy(menu)
		return PLUGIN_HANDLED
		}
	case 6:{
		remove_task(36)
		set_hudmessage(255, 255, 255, -1.0, 0.03, 0, 6.0, 10.0)
		show_hudmessage(0, "Сервер сейчас выключиться")
		set_task (10.0, "serveroff_now",36)
		menu_destroy(menu)
		return PLUGIN_HANDLED
		}
	}

	menu_destroy(menu)
	return PLUGIN_HANDLED
}
 

public message() {
	if(hours>-1) {
		seconds--
		if(seconds==0) {
			seconds=59
			minutes--
			}
		if(minutes==0) {
			hours--
			}
		set_hudmessage(255, 255, 255, -1.0, 0.03, 0, 6.0, 1.0)
		show_hudmessage(0, "Время до выключения сервера: %s%d:%s%d:%s%d",hours<10 ? "0":"",hours,minutes<10 ? "0":"",minutes,seconds<10 ? "0":"",seconds)
		}
		else set_task (10.0, "serveroff_now")
}


public serveroff_now() {
	new players[32],num,i
	get_players(players,num)
	for(i=0;i<num;i++) {
		if(is_user_connected(players[i]))
		server_cmd("kick #%d ^"Сервер выключен^"",players[i])
		server_cmd("quit")  
	}
}

public plugin_end() {
	set_cvar_num("so_minutes",minutes)
	set_cvar_num("so_hours",hours)
	}
